﻿Type=Class
Version=6.31
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private mqtt As MqttClient
	Public IsConnected As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
'
End Sub

Public Sub MQTTConnect(mqttUri As String)
	If IsConnected Then mqtt.close
	Log($"MQTT Connect ${mqttUri}"$)
	mqtt.Initialize("mqtt", mqttUri, "android")
	mqtt.Connect
End Sub

Public Sub MQTTDisconnect
	If IsConnected Then mqtt.close
	IsConnected = False
	CallSubDelayed2(Main, "SetConnected", False)
End Sub

Private Sub mqtt_Connected (Success As Boolean)
	Log($"MQTT connected: ${Success}"$)
	IsConnected = Success
	If IsConnected Then
		mqtt.Subscribe(Main.TopicTemperature, 0)
		mqtt.Subscribe(Main.TopicHumidity, 0)
	Else
		Log($"MQTT connect error: ${LastException.Message}"$)
	End If
	CallSubDelayed2(Main, "SetConnected", Success)
End Sub

' Handle message arrived from the client
Private Sub mqtt_MessageArrived (Topic As String, Payload() As Byte)
	Dim PayLoadStr As String = BytesToString(Payload, 0, Payload.Length, "utf8")
	Log($"MessageArrived: Topic: ${Topic}, PayLoad: ${PayLoadStr}"$)
	CallSubDelayed2(Main, "AddMessage", $"${DateTime.Time(DateTime.Now)}: ${Topic} = ${PayLoadStr}"$)
End Sub
