unit UMisc;

interface
	Uses SysUtils;

	Function DateTimeNow: String;
	Function DateNow: String;
	Function TimeNow: String;
  function CodeUnixDateTime(DateTime: TDateTime): Integer;
  function DeCodeUnixDateTime(DateTime: Integer): TDateTime;
  function DateTimeToUnix2(ConvDate: TDateTime): Longint;
  function UnixToDateTime2(USec: Longint): TDateTime;

implementation

// Get the actual date & time as string
Function DateTimeNow: String;
Begin
	Result := DateToStr(Now) + ' ' + TimeToStr(Now);
End;

// Get the actual date as string
Function DateNow: String;
Begin
	Result := DateToStr(Now);
End;

// Get the actual time as string
Function TimeNow: String;
Begin
	Result := TimeToStr(Now);
End;

function CodeUnixDateTime(DateTime: TDateTime): Integer;
begin
  Result := ((Trunc(DateTime) - 25569) * 86400) +
            Trunc(86400 * (DateTime - Trunc(DateTime))) - 7200;
end;

function DeCodeUnixDateTime(DateTime: Integer): TDateTime;
begin
  Result := ((DateTime + 7200) / 86400) + 25569;
end;

const
  // Sets UnixStartDate to TDateTime of 01/01/1970
  UnixStartDate: TDateTime = 25569.0;

function DateTimeToUnix2(ConvDate: TDateTime): Longint;
begin
  //example: DateTimeToUnix(now);
  Result := Round((ConvDate - UnixStartDate) * 86400);
end;

function UnixToDateTime2(USec: Longint): TDateTime;
begin
  //Example: UnixToDateTime(1003187418);
  Result := (Usec / 86400) + UnixStartDate;
end;

end.
